<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <h2>Registration Car Form</h2>

  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="country-select">Country</label>
      </div>
      <div class="col-sm-3">
        <select id="country-select" name="country" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="region-type-select">Region</label>
      </div>
      <div class="col-sm-3">
        <select id="region-type-select" name="region" class="form-control">
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="car-type-select">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button class="btn btn-info" id="btn-send"> Send </button>
      </div>
    </div>
  </div>
</div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;
  
  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;
  
  var gObjectCarData = JSON.parse(gJsonCarData);

  var gObjCountryData = JSON.parse(gJsonCountryData);
  
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  //thêm sự kiện load trang
  $(document).ready(function(){
    onPageLoading();
  });
  //thêm sự kiện change cho select car
  $("#car-select").on("change", function(){
    onCarSelectChange(this);
  });
  //thêm sự kiện change cho select country
  $("#country-select").on("change", function(){
    onCountrySelectChange(this);
  })
  //thêm sự kiện click nút send
  $("#btn-send").click(function(){
    onBtnSendClick();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý sự kiện load trang
  function onPageLoading(){
    loadDataToSelectCar();
    loadDatatoSelectCountry();
  }
  //hàm sử lý sự kiện change car select
  function onCarSelectChange(paramCarSelect){
    var vBrandId = $(paramCarSelect).val();
    //var vBrandId = $("#car-select").val();
    console.log(vBrandId);

    //load dữ liệu ra car type
    loadDataToSelectCarType(vBrandId)
  }
  //hàm sử lý sự kiện change country select
  function onCountrySelectChange(paramCountryId){
    var vCountryId = $(paramCountryId).val();
    console.log("Country ID: " + vCountryId);
    loadDataToRegionTypeSelectByCountryId(vCountryId);
  }
  //hàm sử lý sự kiện click nút send
  function onBtnSendClick(){
    //b1 khai báo biến và thu thập dữ liệu
    var vCarObj = {
      brandId: -1,
      brandName: "",
      typeId: -1,
      typeName: "",
      countryId: "",
      countryName: "",
      regionId: "",
      regionName: ""
    }
    getCarObjData(vCarObj);
    getFormData(vCarObj);
    //kiểm tra dữ liệu
    var vValid = valiDataCarObj(vCarObj);
    if(vValid){
      sendCarData(vCarObj);
      showDataToConsole(vCarObj);
    }
    //hiẻn thị dữ liệu
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm thu thập dữ liệu trên form
  function getFormData(paramFormObj){
    paramFormObj.brandId = $("#car-select").val();
    paramFormObj.brandName = $("#car-select option:selected").text();
    paramFormObj.typeId = $("#car-type-select").val();
    paramFormObj.typeName = $("#car-type-select option:selected").text();

    paramFormObj.countryId = $("#country-select").val();
    paramFormObj.countryName = $("#country-select option:selected").text();
    paramFormObj.regionId = $("#region-type-select").val();
    paramFormObj.regionName = $("#region-type-select option:selected").text();
  }
  function showDataToConsole(paramFormObj){
    console.log(paramFormObj);
    console.log("Country Id: " + paramFormObj.countryId);
    console.log("Country Name: " + paramFormObj.countryName);
    console.log("Region Id: " + paramFormObj.regionId);
    console.log("Region Name: " + paramFormObj.regionName);
  }
  //hàm load dữ liệu vào select region 
  function loadDataToRegionTypeSelectByCountryId(paramCountryId){
    "use strict";
    var vRegionTypeData = getRegionTypeByCountryId(paramCountryId);
    var vSelectRegion = $("#region-type-select");
    vSelectRegion.html("");

    if(vRegionTypeData.length == 0){
      vSelectRegion.prop("disabled", true);
    }
    else{
      vSelectRegion.prop("disabled", false);

      for(var bI = 0; bI < vRegionTypeData.length; bI++){
        var vRegionOption = $("<option/>", {
          value: vRegionTypeData[bI].regionId,
          text: vRegionTypeData[bI].regionName
        }).appendTo(vSelectRegion);
      }
    }

  } 
  function getRegionTypeByCountryId(paramCountryId){
    var vRegionFound = false;
    var vRegionTypeResult = null;
    var vIndex = 0;
    while(!vRegionFound && vIndex < gObjCountryData.length){
      if(gObjCountryData[vIndex].countryId === paramCountryId){
        vRegionFound = true;
        vRegionTypeResult = gObjCountryData[vIndex].regionTypes;
      }else{
        vIndex++
      }
    }
    return vRegionTypeResult;
  }
  //hàm thực hiện load data vào select contry
  function loadDatatoSelectCountry(){
    var vCountrySelect = $("#country-select");
    for(var bI = 0; bI < gObjCountryData.length; bI++){
      var bOptionCountry = $("<option/>", {
        value: gObjCountryData[bI].countryId,
        text: gObjCountryData[bI].countryName
      }).appendTo(vCountrySelect);
    }
  }
  //hàm load dữ liệu vào selectCar
  function loadDataToSelectCar(){
    var vSelectCar = $("#car-select");
     for(var bI = 0; bI < gObjectCarData.length; bI++){
    //   $("<option/>", {
    //     "value": gObjectCarData[bI].brandId,
    //     "text": gObjectCarData[bI].brandName
    //   }).appendTo($(vSelectCar));
    var bOption = $("<option/>");
      bOption.prop("value", gObjectCarData[bI].brandId);
      bOption.prop("text", gObjectCarData[bI].brandName);
      vSelectCar.append(bOption);
    }
  }
  //laod dữ liệu lên select car type
  function loadDataToSelectCarType(paramBrandId){
    // b1 laod dữ liệu vào brand type
    var vBrandTypes = getBrandTypeByBrandID(paramBrandId);
    //b2 reset select car type
    var vCarTypeSelect = $("#car-type-select");
    vCarTypeSelect.html("");
    //b3 set enable/dissable cho select car type
    if(vBrandTypes.length == 0){
      vCarTypeSelect.prop('disabled', 'disabled');
    }else{
      vCarTypeSelect.prop('disabled', false);
    }
    //load dữ liệu vào select car type
    for(var bI = 0; bI < vBrandTypes.length; bI++){
      $('<option/>', {
        'value': vBrandTypes[bI].typeId,
        'text': vBrandTypes[bI].typeName
      }).appendTo(vCarTypeSelect);
    }
  }
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vBrandTypesResult;
  }
  //hàm thu thập dữ liệu trên form
  function getCarObjData(paramCarObj){
    paramCarObj.brandId = $("#car-select").val();
    //paramCarObj.brandName = $("#car-select option:selected").val();
    paramCarObj.brandName = $("#car-select option:selected").text();
    paramCarObj.typeId = $("#car-type-select").val();
    paramCarObj.typeName = $("#car-type-select option:selected").text();
  }
  //hàm kiểm tra dữ liệu trên form
  function valiDataCarObj(paramCarObj){
    if(paramCarObj.brandId == 0){
      alert("Phải chọn car");
      $("#car-select").focus();
      return false;
    }

    if(paramCarObj.typeId == -1){
      alert("Phải chọn car type");
      $("#car-type-select").focus();
      return false;
    }
    return true;
  }
  //hàm gửi dữ liệu
  function sendCarData(paramCarObj){
    console.log(paramCarObj);
  }
</script> 

</html>